local fire={}
fire.effect = love.graphics.newPixelEffect[[

extern number time;
extern vec2 screen;

vec3 iscreen = vec3(screen.x,screen.y,100.);
number iGlobalTime = time;

// by @301z - modified for Love by Ref 10/16/2013

number rand(vec2 n) {
	return fract(sin(dot(n, vec2(13, 5))) * 43758.5453);
}

number noise(vec2 n) {
	vec2 d = vec2(0.0, 1.0);
	vec2 b = floor(n), f = smoothstep(vec2(0.0), vec2(1.0), fract(n));
	return mix(mix(rand(b), rand(b + d.yx), f.x), mix(rand(b + d.xy), rand(b + d.yy), f.x), f.y);
}

number fbm(vec2 n) {
	number total = 0.0, amplitude = 1.0;
	for (int i = 0; i < 7; i++) {
		total += noise(n) * amplitude;
		n += n;
		amplitude *= 0.75;
	}
	return total;
}

vec4 effect( vec4 color, Image tex, vec2 tc, vec2 pc )
	{
	vec3 c1 = vec3(0.1, 0.0, 0.0);
	vec3 c2 = vec3(0.7, 0.0, 0.0);
	vec3 c3 = vec3(0.2, 0.0, 0.0);
	vec3 c4 = vec3(1.0, 0.9, 0.0);
	vec3 c5 = vec3(0.1);
	vec3 c6 = vec3(0.9);
	vec2 p = pc.xy * 8.0 / iscreen.xx;
	number q = fbm(p - iGlobalTime * 0.1);
	vec2 r = vec2(fbm(p + q + iGlobalTime * 0.7 - p.x - p.y), fbm(p + q - iGlobalTime * 0.4));
	vec3 c = mix(c1, c2, fbm(p + r)) + mix(c3, c4, r.x) - mix(c5, c6, r.y);
	return vec4(c * cos(1.57 * pc.y / iscreen.y), 1.0);
	}
]]
return fire

